// sign_up_otp_repository.dart
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:mypoint_flutter_app/networking/restful_api_request.dart';
import '../../base/base_response_model.dart';
import '../../base/restful_api_viewmodel.dart';
import 'otp_verify_response_model.dart';
import 'otp_view_model.dart';

class VerifyOtpRepository extends RestfulApiViewModel implements IOtpRepository {
  int otpTtl;
  final String mfaToken;
  var otpVerifyResponse = BaseResponseModel<OTPVerifyResponseModel>().obs;
  VerifyOtpRepository(this.phoneNumber, this.otpTtl, this.mfaToken);

  @override
  String phoneNumber;

  @override
  Future<void> sendOtp() async {}

  @override
  Future<BaseResponseModel<OTPVerifyResponseModel>> verifyOtp(String otpCode) async {
    showLoading();
    return client.verifyOTP(otpCode, mfaToken).then((value) {
      hideLoading();
      return value;
    });
  }

  @override
  Future<void> resendOtp() async {
    showLoading();
    return client.resendOTP(mfaToken).then((value) {
      otpTtl = value.data?.otpTtl ?? 0;
      hideLoading();
    });
  }
}
